# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
"""
This file contains the exact signatures for all functions in module
PySide6.QtLocation, except for defaults which are replaced by "...".
"""

# mypy: disable-error-code="override, overload-overlap"
# Module `PySide6.QtLocation`

import PySide6.QtLocation
import PySide6.QtCore

import enum
import typing
from PySide6.QtCore import Signal
from shiboken6 import Shiboken


class QGeoCodeReply(PySide6.QtCore.QObject):

    aborted                  : typing.ClassVar[Signal] = ... # aborted()
    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QGeoCodeReply::Error,QString); errorOccurred(QGeoCodeReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished()

    class Error(enum.Enum):

        NoError                   = 0x0
        EngineNotSetError         = 0x1
        CommunicationError        = 0x2
        ParseError                = 0x3
        UnsupportedOptionError    = 0x4
        CombinationError          = 0x5
        UnknownError              = 0x6


class QGeoCodingManager(PySide6.QtCore.QObject):

    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QGeoCodeReply*,QGeoCodeReply::Error,QString); errorOccurred(QGeoCodeReply*,QGeoCodeReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished(QGeoCodeReply*)


class QGeoCodingManagerEngine(PySide6.QtCore.QObject):

    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QGeoCodeReply*,QGeoCodeReply::Error,QString); errorOccurred(QGeoCodeReply*,QGeoCodeReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished(QGeoCodeReply*)


class QGeoManeuver(Shiboken.Object):

    class InstructionDirection(enum.Enum):

        NoDirection               = 0x0
        DirectionForward          = 0x1
        DirectionBearRight        = 0x2
        DirectionLightRight       = 0x3
        DirectionRight            = 0x4
        DirectionHardRight        = 0x5
        DirectionUTurnRight       = 0x6
        DirectionUTurnLeft        = 0x7
        DirectionHardLeft         = 0x8
        DirectionLeft             = 0x9
        DirectionLightLeft        = 0xa
        DirectionBearLeft         = 0xb


class QGeoRoute(Shiboken.Object): ...


class QGeoRouteReply(PySide6.QtCore.QObject):

    aborted                  : typing.ClassVar[Signal] = ... # aborted()
    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QGeoRouteReply::Error,QString); errorOccurred(QGeoRouteReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished()

    class Error(enum.Enum):

        NoError                   = 0x0
        EngineNotSetError         = 0x1
        CommunicationError        = 0x2
        ParseError                = 0x3
        UnsupportedOptionError    = 0x4
        UnknownError              = 0x5


class QGeoRouteRequest(Shiboken.Object):

    class FeatureType(enum.Flag):

        NoFeature                 = 0x0
        TollFeature               = 0x1
        HighwayFeature            = 0x2
        PublicTransitFeature      = 0x4
        FerryFeature              = 0x8
        TunnelFeature             = 0x10
        DirtRoadFeature           = 0x20
        ParksFeature              = 0x40
        MotorPoolLaneFeature      = 0x80
        TrafficFeature            = 0x100

    class FeatureWeight(enum.Flag):

        NeutralFeatureWeight      = 0x0
        PreferFeatureWeight       = 0x1
        RequireFeatureWeight      = 0x2
        AvoidFeatureWeight        = 0x4
        DisallowFeatureWeight     = 0x8

    class ManeuverDetail(enum.Flag):

        NoManeuvers               = 0x0
        BasicManeuvers            = 0x1

    class RouteOptimization(enum.Flag):

        ShortestRoute             = 0x1
        FastestRoute              = 0x2
        MostEconomicRoute         = 0x4
        MostScenicRoute           = 0x8

    class SegmentDetail(enum.Flag):

        NoSegmentData             = 0x0
        BasicSegmentData          = 0x1

    class TravelMode(enum.Flag):

        CarTravel                 = 0x1
        PedestrianTravel          = 0x2
        BicycleTravel             = 0x4
        PublicTransitTravel       = 0x8
        TruckTravel               = 0x10


class QGeoRouteSegment(Shiboken.Object): ...


class QGeoRoutingManager(PySide6.QtCore.QObject):

    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QGeoRouteReply*,QGeoRouteReply::Error,QString); errorOccurred(QGeoRouteReply*,QGeoRouteReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished(QGeoRouteReply*)


class QGeoRoutingManagerEngine(PySide6.QtCore.QObject):

    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QGeoRouteReply*,QGeoRouteReply::Error,QString); errorOccurred(QGeoRouteReply*,QGeoRouteReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished(QGeoRouteReply*)


class QGeoServiceProvider(PySide6.QtCore.QObject):

    class Error(enum.Enum):

        NoError                   = 0x0
        NotSupportedError         = 0x1
        UnknownParameterError     = 0x2
        MissingRequiredParameterError = 0x3
        ConnectionError           = 0x4
        LoaderError               = 0x5

    class GeocodingFeature(enum.Flag):

        AnyGeocodingFeatures      = -1
        NoGeocodingFeatures       = 0x0
        OnlineGeocodingFeature    = 0x1
        OfflineGeocodingFeature   = 0x2
        ReverseGeocodingFeature   = 0x4
        LocalizedGeocodingFeature = 0x8

    class MappingFeature(enum.Flag):

        AnyMappingFeatures        = -1
        NoMappingFeatures         = 0x0
        OnlineMappingFeature      = 0x1
        OfflineMappingFeature     = 0x2
        LocalizedMappingFeature   = 0x4

    class NavigationFeature(enum.Flag):

        AnyNavigationFeatures     = -1
        NoNavigationFeatures      = 0x0
        OnlineNavigationFeature   = 0x1
        OfflineNavigationFeature  = 0x2

    class PlacesFeature(enum.Flag):

        AnyPlacesFeatures         = -1
        NoPlacesFeatures          = 0x0
        OnlinePlacesFeature       = 0x1
        OfflinePlacesFeature      = 0x2
        SavePlaceFeature          = 0x4
        RemovePlaceFeature        = 0x8
        SaveCategoryFeature       = 0x10
        RemoveCategoryFeature     = 0x20
        PlaceRecommendationsFeature = 0x40
        SearchSuggestionsFeature  = 0x80
        LocalizedPlacesFeature    = 0x100
        NotificationsFeature      = 0x200
        PlaceMatchingFeature      = 0x400

    class RoutingFeature(enum.Flag):

        AnyRoutingFeatures        = -1
        NoRoutingFeatures         = 0x0
        OnlineRoutingFeature      = 0x1
        OfflineRoutingFeature     = 0x2
        LocalizedRoutingFeature   = 0x4
        RouteUpdatesFeature       = 0x8
        AlternativeRoutesFeature  = 0x10
        ExcludeAreasRoutingFeature = 0x20


class QGeoServiceProviderFactory(Shiboken.Object): ...


class QIntList: ...


class QLocation(Shiboken.Object):

    class Visibility(enum.Flag):

        UnspecifiedVisibility     = 0x0
        DeviceVisibility          = 0x1
        PrivateVisibility         = 0x2
        PublicVisibility          = 0x4


class QPlace(Shiboken.Object): ...


class QPlaceAttribute(Shiboken.Object): ...


class QPlaceCategory(Shiboken.Object): ...


class QPlaceContactDetail(Shiboken.Object): ...


class QPlaceContent(Shiboken.Object):

    class DataTag(enum.Enum):

        ContentSupplier           = 0x0
        ContentUser               = 0x1
        ContentAttribution        = 0x2
        ImageId                   = 0x3
        ImageUrl                  = 0x4
        ImageMimeType             = 0x5
        EditorialTitle            = 0x6
        EditorialText             = 0x7
        EditorialLanguage         = 0x8
        ReviewId                  = 0x9
        ReviewDateTime            = 0xa
        ReviewTitle               = 0xb
        ReviewText                = 0xc
        ReviewLanguage            = 0xd
        ReviewRating              = 0xe
        CustomDataTag             = 0x3e8

    class Type(enum.Enum):

        NoType                    = 0x0
        ImageType                 = 0x1
        ReviewType                = 0x2
        EditorialType             = 0x3
        CustomType                = 0x100


class QPlaceContentReply(PySide6.QtLocation.QPlaceReply): ...


class QPlaceContentRequest(Shiboken.Object): ...


class QPlaceDetailsReply(PySide6.QtLocation.QPlaceReply): ...


class QPlaceIcon(Shiboken.Object): ...


class QPlaceIdReply(PySide6.QtLocation.QPlaceReply):

    class OperationType(enum.Enum):

        SavePlace                 = 0x0
        SaveCategory              = 0x1
        RemovePlace               = 0x2
        RemoveCategory            = 0x3


class QPlaceManager(PySide6.QtCore.QObject):

    categoryAdded            : typing.ClassVar[Signal] = ... # categoryAdded(QPlaceCategory,QString)
    categoryRemoved          : typing.ClassVar[Signal] = ... # categoryRemoved(QString,QString)
    categoryUpdated          : typing.ClassVar[Signal] = ... # categoryUpdated(QPlaceCategory,QString)
    dataChanged              : typing.ClassVar[Signal] = ... # dataChanged()
    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QPlaceReply*,QPlaceReply::Error,QString); errorOccurred(QPlaceReply*,QPlaceReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished(QPlaceReply*)
    placeAdded               : typing.ClassVar[Signal] = ... # placeAdded(QString)
    placeRemoved             : typing.ClassVar[Signal] = ... # placeRemoved(QString)
    placeUpdated             : typing.ClassVar[Signal] = ... # placeUpdated(QString)


class QPlaceManagerEngine(PySide6.QtCore.QObject):

    categoryAdded            : typing.ClassVar[Signal] = ... # categoryAdded(QPlaceCategory,QString)
    categoryRemoved          : typing.ClassVar[Signal] = ... # categoryRemoved(QString,QString)
    categoryUpdated          : typing.ClassVar[Signal] = ... # categoryUpdated(QPlaceCategory,QString)
    dataChanged              : typing.ClassVar[Signal] = ... # dataChanged()
    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QPlaceReply*,QPlaceReply::Error,QString); errorOccurred(QPlaceReply*,QPlaceReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished(QPlaceReply*)
    placeAdded               : typing.ClassVar[Signal] = ... # placeAdded(QString)
    placeRemoved             : typing.ClassVar[Signal] = ... # placeRemoved(QString)
    placeUpdated             : typing.ClassVar[Signal] = ... # placeUpdated(QString)


class QPlaceMatchReply(PySide6.QtLocation.QPlaceReply): ...


class QPlaceMatchRequest(Shiboken.Object): ...


class QPlaceProposedSearchResult(PySide6.QtLocation.QPlaceSearchResult): ...


class QPlaceRatings(Shiboken.Object): ...


class QPlaceReply(PySide6.QtCore.QObject):

    aborted                  : typing.ClassVar[Signal] = ... # aborted()
    contentUpdated           : typing.ClassVar[Signal] = ... # contentUpdated()
    errorOccurred            : typing.ClassVar[Signal] = ... # errorOccurred(QPlaceReply::Error,QString); errorOccurred(QPlaceReply::Error)
    finished                 : typing.ClassVar[Signal] = ... # finished()

    class Error(enum.Enum):

        NoError                   = 0x0
        PlaceDoesNotExistError    = 0x1
        CategoryDoesNotExistError = 0x2
        CommunicationError        = 0x3
        ParseError                = 0x4
        PermissionsError          = 0x5
        UnsupportedError          = 0x6
        BadArgumentError          = 0x7
        CancelError               = 0x8
        UnknownError              = 0x9

    class Type(enum.Enum):

        Reply                     = 0x0
        DetailsReply              = 0x1
        SearchReply               = 0x2
        SearchSuggestionReply     = 0x3
        ContentReply              = 0x4
        IdReply                   = 0x5
        MatchReply                = 0x6


class QPlaceResult(PySide6.QtLocation.QPlaceSearchResult): ...


class QPlaceSearchReply(PySide6.QtLocation.QPlaceReply): ...


class QPlaceSearchRequest(Shiboken.Object):

    class RelevanceHint(enum.Enum):

        UnspecifiedHint           = 0x0
        DistanceHint              = 0x1
        LexicalPlaceNameHint      = 0x2


class QPlaceSearchResult(Shiboken.Object):

    class SearchResultType(enum.Enum):

        UnknownSearchResult       = 0x0
        PlaceResult               = 0x1
        ProposedSearchResult      = 0x2


class QPlaceSearchSuggestionReply(PySide6.QtLocation.QPlaceReply): ...


class QPlaceSupplier(Shiboken.Object): ...


class QPlaceUser(Shiboken.Object): ...


# eof
